/**
 * bagpipe组件
 */
const Bagpipe = require('bagpipe');
const fs = require('fs');

const Http = require('./http');

// 设定最大并发数为100
const bagpipe = new Bagpipe(100);

module.exports = {
  /**
   * 下载文件到本地
   * @param url
   * @param path
   */
  downFile(url, path) {
    bagpipe.push(() => {
      Http.get({
        url,
        responseType: 'stream',
      }).then((response) => {
        response.data.pipe(fs.createWriteStream(path));
      });
    });
  },
};
