/**
 * 微信企业号组件
 */
const API = require('wechat-enterprise').API;

const Log = require('../log');

let res = {
  // 企业id
  corpId: 'ww8fb237b5ac55178a',
  // 应用密钥
  agentSecret: 'G9FX58b74c7nuIBv3iYm3z_ctrUR2NsqMcTmm-bLr28',
  // 应用id
  agentId: '1000002',
};

try {
  res = require(`${process.cwd()}/configs/${process.env.NODE_ENV}/wechat.json`);
} catch (e) {
  Log.warn(`Not found wechat.json from configs/${process.env.NODE_ENV} folder. Use default value ${JSON.stringify(res)}`);
}

const api = new API(
  res.corpId,
  res.agentSecret,
  res.agentId,
);

module.exports = {
  /**
   * 发送通知
   * @param message
   */
  message(message) {
    api.send({
      touser: '@all',
    }, {
      msgtype: 'text',
      text: {
        content: message,
      },
      safe: '0',
    }, (err, result) => {
      // 如果失败则记录日志
      if (err) {
        Log.error(err);
      } else {
        console.log(`发送微信通知成功, ${JSON.stringify(result)}`);
      }
    });
  },
};
