/**
 * aliOss组件
 */
const Oss = require('ali-oss');

const Log = require('../log');
const Moment = require('../moment');
const Uuid = require('../uuid');
const CoreError = require('../errors/core');

let res = {
  endpoint: 'http://oss-cn-hangzhou.aliyuncs.com',
  accessKeyId: 'LTAIlqLMpJvcVrM3',
  accessKeySecret: '345JoSNBrL3GXBWgcovsoxikMcXgEC',
  bucket: 'clouddoo-test',
};

try {
  res = require(`${process.cwd()}/configs/${process.env.NODE_ENV}/aliOss.json`);
} catch (e) {
  Log.warn(`Not found aliOss.json from configs/${process.env.NODE_ENV} folder. Use default value ${JSON.stringify(res)}`);
}

const oss = new Oss(res);

module.exports = {
  /**
   * upload
   * @param packagePrefix
   * @param fileExt
   * @param buffer
   * @returns {Promise<*>}
   */
  async upload(packagePrefix, fileExt, buffer) {
    const packageName = Moment().format('YYYY/MM/DD');
    const fileName = Uuid.generate();
    const key = `${packagePrefix}/${packageName}/${fileName}.${fileExt}`;

    try {
      const result = await oss.put(key, buffer);
      return result.url;
    } catch (e) {
      throw new CoreError('上传失败');
    }
  },
};
