/**
 * 推送组件
 */
const jpush = require('jpush-sdk');

const Log = require('./log');

let res = {
  appKey: '3633d99a41721cc70c141d2a',
  masterSecret: 'b29d400203eee2fcd9054d66',
};

try {
  res = require(`${process.cwd()}/configs/${process.env.NODE_ENV}/push.json`);
} catch (e) {
  Log.warn(`Not found push.json from configs/${process.env.NODE_ENV} folder. Use default value ${JSON.stringify(res)}`);
}

const client = jpush.buildClient(res.appKey, res.masterSecret);

module.exports = {
  simple(notification, opts) {
    opts = opts || {};
    const platform = opts.platform || jpush.ALL;
    const audience = opts.audience || jpush.ALL;

    const extras = opts.extras || {};
    const dev = opts.dev || false;

    const p = client.push().setPlatform(platform)
      .setAudience(audience)
      .setNotification(notification, jpush.ios(notification, 'happy', '+1', null, extras))
      .send((err) => {
        if (err) {
          Log.error(`push error, reason: ${err.message}, 
          platform: ${platform}, audicence: ${JSON.stringify(audience)}, 
          notification: ${notification}`);
        } else {
          Log.info(`push success, platform: ${platform}, 
          audicence: ${JSON.stringify(audience)}, notification: ${notification}`);
        }
      });

    if (!dev) {
      p.setOptions(null, null, null, true, null);
    }
  },

  alias(value) {
    return jpush.alias(value);
  },
};
