/**
 * 阿里短信组件
 */
const SMSClient = require('@alicloud/sms-sdk');

const Log = require('../log');

let res = {
  accessKeyId: 'LTAIGK5jE8q8KBnM',
  secretAccessKey: '0GZXFxWuYmdKlEiMiJIndQ8N629iPf',
  signName: '天使停车',
  templateCode: 'SMS_151550112',
};

try {
  res = require(`${process.cwd()}/configs/${process.env.NODE_ENV}/aliSms.json`);
} catch (e) {
  Log.warn(`Not found aliSms.json from configs/${process.env.NODE_ENV} folder. Use default value ${JSON.stringify(res)}`);
}

const smsClient = new SMSClient({
  accessKeyId: res.accessKeyId,
  secretAccessKey: res.secretAccessKey,
});

module.exports = {
  async send(mobile, message) {
    const result = await smsClient.sendSMS({
      PhoneNumbers: mobile,
      SignName: res.signName,
      TemplateCode: res.templateCode,
      TemplateParam: `{"code":"${message}"}`,
    });

    if (result.Code === 'OK') {
      Log.info(`短信发送成功 ${mobile} ${message}`);
    } else {
      Log.error(`短信发送失败 ${result.Code} ${mobile}`);
    }
  },

  async custom(mobile, opts) {
    opts = opts || {};

    const code = opts.templateCode || 'templateCode';
    const param = opts.param || '';

    const json = {
      PhoneNumbers: mobile,
      SignName: res.signName,
      TemplateCode: res[code],
    };

    if (param) {
      json.TemplateParam = param;
    }

    const result = await smsClient.sendSMS(json);

    if (result.Code === 'OK') {
      Log.info(`短信发送成功 ${mobile} ${param}`);
    } else {
      Log.error(`短信发送失败 ${result.Code} ${mobile}`);
    }
  },
};
