/**
 * api中间件
 */
const router = require('koa-router')();

const _ = require('../components/lodash');
const Api = require('../components/api');

module.exports = (app, prefix, apis) => {
  // 生成路由
  _.forEach(apis, (api) => {
    // 判断路由有没有实例化Api
    if (!(api instanceof Api({ notNew: true }))) {
      throw new Error('every api must be instanceof Api');
    }

    // set routes
    router.use(prefix, api.getRouter().routes());
  });

  app.use(router.routes());

  return async (ctx, next) => {
    await next();
  };
};
