/**
 * 日志中间件
 */
const Log = require('../components/log');

module.exports = {
  /**
   * 渲染开始
   * @returns {Function}
   */
  renderStart() {
    return async (ctx, next) => {
      let message = `render start ${ctx.request.method} ${ctx.request.url}`;

      if (ctx.request.method !== 'GET') {
        message = `${message} ${JSON.stringify(ctx.request.body)}`;
      }

      Log.info(message);
      await next();
    };
  },

  /**
   * 启动开始
   * @param port
   */
  appStart(port) {
    Log.info(`app started at port ${port}...`);
  },
};
