/**
 * 限流中间件
 */
const ratelimit = require('koa-ratelimit');

const Redis = require('../components/redis');

module.exports = () => ratelimit({
  db: Redis.redis,
  duration: 3600000, // 单位：ms
  id: ctx => ctx.ip,
  headers: {
    remaining: 'Rate-Limit-Remaining',
    reset: 'Rate-Limit-Reset',
    total: 'Rate-Limit-Total',
  },
  max: 2500, // max requests
  disableHeader: false,
  throw: true,
});
